/*
SUPPORT: sinavk Khairnar, Avinash
*/
/******************************************************************************
 * Job:             Load_STG2DM_Product_attributes          A5W0V4GZ.BF0002M4 *
 * Description:                                                               *
 *                                                                            *
 * Metadata Server: puneasd10.apac.sas.com                                    *
 * Port:            8561                                                      *
 * Location:        /Users/Manas/My Folder/Job/change_flg                     *
 *                                                                            *
 * Server:          MIMain                                  A5W0V4GZ.AR000003 *
 *                                                                            *
 * Source Tables:   STG_PRODUCT_ATTRIBUTES -                A5W0V4GZ.BB0007XD *
 *                   DIDM_STG.STG_PRODUCT_ATTRIBUTES                          *
 *                  ATTRIBUTE - DI_DM.ATTRIBUTE             A5W0V4GZ.BB0007YE *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0007U1 *
 *                  PRODUCT_ATTRIBUTES -                    A5W0V4GZ.BB00082X *
 *                   DI_DM.PRODUCT_ATTRIBUTES                                 *
 * Target Tables:   STG_PRODUCT_ATTRIBUTES_X -              A5W0V4GZ.BB0007V7 *
 *                   DI_MON.STG_PRODUCT_ATTRIBUTES_X                          *
 *                  ATTRIBUTE_HISTORY -                     A5W0V4GZ.BB0007YF *
 *                   DI_DM.ATTRIBUTE_HISTORY                                  *
 *                  PRODUCT_ATTRIBUTES -                    A5W0V4GZ.BB00082X *
 *                   DI_DM.PRODUCT_ATTRIBUTES                                 *
 *                                                                            *
 * Generated on:    Friday, November 6, 2009 2:40:49 PM GMT+05:30             *
 * Generated by:    sinmna@row                                                *
 * Version:         SAS Data Integration Studio 4.2                           *
 ******************************************************************************/

/* General macro variables  */
%let jobID = %quote(A5W0V4GZ.BF0002M4);
%let etls_jobName = %nrquote(Load_STG2DM_Product_attributes);
%let etls_userID = %nrquote(sinmna@row);

/* Setup to capture return codes  */
%global job_rc trans_rc sqlrc;
%let sysrc = 0;
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr;

%macro rcSet(error);
   %if (&error gt &trans_rc) %then
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then
      %let job_rc = &error;
%mend rcSet;


/* Create metadata macro variables */
%let IOMServer      = %nrquote(MIMain);

/* Setup for capturing job status  */
%let etls_startTime = %sysfunc(datetime(),datetime.);
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

%global etls_debug;
%macro etls_setDebug;
   %if %str(&etls_debug) ne 0 %then
      OPTIONS MPRINT%str(;);
%mend;
%etls_setDebug;

/*---- Start of Pre-Process Code  ----*/

/**/
%etl_initjobparam (monlib=di_mon, jobname=%nrquote(&etls_jobName));
/**/
%etl_initchangeflags;
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

/*============================================================================*
 * Step:            Uw_check_exist                          A5W0V4GZ.BH000HWM *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    STG_PRODUCT_ATTRIBUTES -                A5W0V4GZ.BB0007XD *
 *                   DIDM_STG.STG_PRODUCT_ATTRIBUTES                          *
 * Target Table:    Uw_check_exist -                        A5W0V4GZ.BK000ENG *
 *                   work.Stg_product_attributes                              *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWM);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(DIDM_STG.STG_PRODUCT_ATTRIBUTES);


/*---- Start of User Written Code  ----*/


%macro etl_check_exist;

   %let abort = 0 ;

      /* Check for existence of DI_MON.PROD_HIER_SK dataset */
   %if NOT %sysfunc(exist(DI_MON.PROD_HIER_SK)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_MON.PROD_HIER_SK);
      %put &etl_msg;
      %let abort = 3 ;
   %end;

   /* Check for existence of DI_DM.ATTRIBUTE dataset */
   %if NOT %sysfunc(exist(DI_DM.ATTRIBUTE)) %then
   %do;
      %let etl_msg = %etl_msg(mid=5005,args=DI_DM.ATTRIBUTE);
      %put &etl_msg;
      %let abort = 4 ;
   %end;

   /* ETLP_DATE_FORMAT from DI_MON.JOB_PARAM */

   %if &ETLP_DATE_FORMAT eq %str() %then
   %do;
      %let etl_msg = %etl_msg(mid=5007,args=ETLP_DATE_FORMAT DI_MON.JOB_PARAM);
      %put &etl_msg;
      %let abort = 5 ;
   %end;

   /* ETLP_DATETIME_FORMAT from DI_MON.JOB_PARAM */

   %if &ETLP_DATETIME_FORMAT eq %str() %then
   %do;
      %let etl_msg = %etl_msg(mid=5007,args=ETLP_DATETIME_FORMAT DI_MON.JOB_PARAM);
      %put &etl_msg;
      %let abort = 6 ;
   %end;

   %if NOT %symexist(etlp_use_hash_lookup) %then %do;
      %let etl_msg = %etl_msg(mid=5012,args=ETLP_USE_HASH_LOOKUP DI_MON.JOB_PARAM);
      %put &etl_msg;
      %let abort = 7 ;
   %end;
   /* masking etlp_excl_char_list and adding pipe "|" default symbol*/
   %let etlp_exclude_char_list = %superq(etlp_exclude_char_list)|;
   %put ETLP_EXCLUDE_CHAR_LIST = &etlp_exclude_char_list;
   %put ETLP_DATE_FORMAT = &ETLP_DATE_FORMAT ;
   %put ETLP_DATETIME_FORMAT = &ETLP_DATETIME_FORMAT ;

   %if &abort gt 0 %then
   %do;
      %etl_abort;
   %end;

%mend etl_check_exist;

%etl_check_exist;

/* Converting  ATTRIBUTE NAME to upper case */
data work.Stg_product_attributes;;
set &SYSLAST;
PROD_ATTR_NM=UPCASE(PROD_ATTR_NM);
CHANGE_FLG=UPCASE(CHANGE_FLG);
run;


/*---- End of User Written Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);


/**  Step end Uw_check_exist **/

/*============================================================================*
 * Step:            Lkp_attribute_prod_hier_sk              A5W0V4GZ.BH000HWN *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   Uw_check_exist -                        A5W0V4GZ.BK000ENG *
 *                   work.Stg_product_attributes                              *
 *                  ATTRIBUTE - DI_DM.ATTRIBUTE             A5W0V4GZ.BB0007YE *
 *                  PROD_HIER_SK - DI_MON.PROD_HIER_SK      A5W0V4GZ.BB0007U1 *
 * Target Table:    Lkp_attribute_prod_hier_sk -            A5W0V4GZ.BK000ENH *
 *                   work.Lkp_attribute_prod_hier_sk                          *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWN);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let runTime = %sysfunc(datetime());

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Lkp_attribute_prod_hier_sk;
quit;

/*---- Begin DATA step to perform lookups  ----*/
DATA  work.Lkp_attribute_prod_hier_sk
         ( keep = PROD_HIER_SK PROD_ATTR_SK ATTR_TYPE PROD_ID PROD_ATTR_NM PROD_ATTR_VALUE
                 CHANGE_FLG )
      ;

   attrib PROD_HIER_SK length=6
          PROD_ATTR_SK length=4
          ATTR_TYPE length=4
          PROD_ID length=$32
          PROD_ATTR_NM length=$40
          PROD_ATTR_VALUE length=$40
          CHANGE_FLG length=$1
          ATTR_SK length= 4
          ATTR_NM length= $40
          ;

   retain missing0-missing1 0;

   etls_assign_target_value = 0;
   /* Build hash objects from lookup tables before reading first source row  */
   if (_n_ = 1) then
   do;
      /* Build hash h0 from lookup table DI_DM.ATTRIBUTE */
      nlobs = .;
      dsid = open("DI_DM.ATTRIBUTE");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h0(dataset: "DI_DM.ATTRIBUTE", hashexp: exponent);
            h0.defineKey( "ATTR_NM");
            h0.defineData( "ATTR_SK",
                           "ATTR_TYPE");
            h0.defineDone();
            if (nlobs = -1) then
            do;
               if (h0.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_DM.ATTRIBUTE";
                  missing0 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_DM.ATTRIBUTE";
            missing0 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened: DI_DM.ATTRIBUTE";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_DM.ATTRIBUTE";

         abort 3;
      end;

      /* Build hash h1 from lookup table DI_MON.PROD_HIER_SK */
      nlobs = .;
      dsid = open("DI_MON.PROD_HIER_SK");
      if (dsid > 0) then
      do;
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
            nlobs = attrn(dsid, 'NLOBS');
         else
            nlobs = -1;

         dsid = close(dsid);
         if (nlobs ^= 0) then
         do;
            if (nlobs > 0) then
               exponent = ceil(log2(nlobs));
            else
               exponent = 8;
            declare hash h1(dataset: "DI_MON.PROD_HIER_SK", hashexp: exponent);
            h1.defineKey( "PROD_ID");
            h1.defineData( "PROD_HIER_SK");
            h1.defineDone();
            if (nlobs = -1) then
            do;
               if (h1.Num_Items < 1) then
               do;
                  put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
                  missing1 = 98;
               end;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table is empty: DI_MON.PROD_HIER_SK";
            missing1 = 98;
         end;
      end;
      else
      do;
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " DI_MON.PROD_HIER_SK";

         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " DI_MON.PROD_HIER_SK";

         abort 3;
      end;

      call missing (ATTR_NM, ATTR_SK, ATTR_TYPE, PROD_ID, PROD_HIER_SK);

   end; /* All hash objects have been defined */

   /* Read a row from the source table  */
   set work.Stg_product_attributes end = eof;

   /* Is the current key value stored in hash h0?  */
   if (missing0 < 1) then
   do;
      ATTR_NM = PROD_ATTR_NM;
      rc0 = h0.find();
      PROD_ATTR_SK = ATTR_SK;
   end;
   else
      rc0 = missing0;

   /* Is the current key value stored in hash h1?  */
   if (missing1 < 1) then
   do;
      rc1 = h1.find();
   end;
   else
      rc1 = missing1;

   /* Examine success of lookups  */
   if ( rc0=0 and rc1=0 ) then
   do;
      /* Write row to target  */
      output work.Lkp_attribute_prod_hier_sk;
      return;
   end;
   else
   do;
      error_total + 1;

      if (rc0 ^= 0) then
      do;
         exception_total + 1;
         if (rc0 = 98) then
         do;
            /* Check: Lookup table has no rows-Write exception row  */
            /* Check: Lookup table has no rows-Set target columns to value  */
            /* Check: Lookup table has no rows-Set target columns to missing  */
            call missing (PROD_ATTR_SK, ATTR_TYPE);
            etls_assign_target_value = 1;
         end;

         else
         do;
            /* Check: Lookup value not found-Set target columns to missing  */
            call missing (PROD_ATTR_SK, ATTR_TYPE);
            etls_assign_target_value = 1;
         end;
      end;

      if (rc1 ^= 0) then
      do;
         exception_total + 1;
         if (rc1 = 98) then
         do;
            /* Check: Lookup table has no rows-Write exception row  */
            /* Check: Lookup table has no rows-Set target columns to value  */
            /* Check: Lookup table has no rows-Set target columns to missing  */
            call missing (PROD_HIER_SK);
            etls_assign_target_value = 1;
         end;

         else
         do;
            /* Check: Lookup value not found-Set target columns to missing  */
            call missing (PROD_HIER_SK);
            etls_assign_target_value = 1;
         end;
      end;

      /* Set target columns to value/missing requested?  */
      if (etls_assign_target_value eq 1) then
         /* Write row to target  */
         output work.Lkp_attribute_prod_hier_sk;

   end; /* One or more lookups failed */

   if (eof = 1) then
   do;
      put "Source records with errors: " error_total ;
      put "Total lookup exceptions: " exception_total ;
   end;

run;

%rcSet(&syserr);



/**  Step end Lkp_attribute_prod_hier_sk **/

/*============================================================================*
 * Step:            Sort_stg_product_attributes             A5W0V4GZ.BH000HWO *
 * Transform:       Sort                                                      *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lkp_attribute_prod_hier_sk -            A5W0V4GZ.BK000ENH *
 *                   work.Lkp_attribute_prod_hier_sk                          *
 * Target Table:    Sort_stg_product_attributes -           A5W0V4GZ.BK000ENI *
 *                   work.Sort_stg_product_attributes                         *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWO);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.Lkp_attribute_prod_hier_sk);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(Lkp_attribute_prod_hier_sk);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete Sort_stg_product_attributes;
quit;

proc sort data = &SYSLAST
   out = work.Sort_stg_product_attributes;
   by
      PROD_HIER_SK
      PROD_ATTR_SK
   ;
run;

%rcSet(&syserr);



/**  Step end Sort_stg_product_attributes **/

/*============================================================================*
 * Step:            Uw_remove_duplicates                    A5W0V4GZ.BH000HWP *
 * Transform:       User Written                                              *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Sort_stg_product_attributes -           A5W0V4GZ.BK000ENI *
 *                   work.Sort_stg_product_attributes                         *
 * Target Table:    Uw_remove_duplicates -                  A5W0V4GZ.BK000ENJ *
 *                   work.Uw_remove_duplicates                                *
 *                                                                            *
 * User Written:    SourceCode                                                *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWP);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.Sort_stg_product_attributes);

%let ETLS_SYSLAST = work.Sort_stg_product_attributes;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(Sort_stg_product_attributes);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = work.Sort_stg_product_attributes;


/*---- Start of User Written Code  ----*/

%let callernotes = %sysfunc(getoption(notes));
options nonotes;

data work.Splt_no_duplicates (drop=ETLS_EXCEPTION_COND ETL_ERROR_JOBRUNTIME)
     work.Splt_duplicates (keep=%di_util_column_names(DI_MON.STG_PRODUCT_ATTRIBUTES_X));
     attrib ETLS_EXCEPTION_COND length=$300;
   set work.Sort_stg_product_attributes;
   by prod_hier_sk prod_attr_sk;

   if not last.prod_attr_sk then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5351)"),$300.);
      end;
   if missing(prod_hier_sk) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ID)"),$300.);
      end;
   if missing(prod_attr_sk) then
      do;
         ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5305,args=PROD_ATTR_NM)"),$300.);
      end;
   if MISSING(ETLS_EXCEPTION_COND) then do;
      select (ATTR_TYPE);

         /* 1 = Decimal */
         when (1) do;
            if missing(input(PROD_ATTR_VALUE,nlnum12.2))
            then ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
            else PROD_ATTR_VALUE = cats(put(input(PROD_ATTR_VALUE,nlnum12.2),nlbest12.2));
            _ERROR_=0;
         end;


         /* 2 = Character  by default Pipe "|" is not allowed in the PROD_ATTR_VALUE*/
         when (2) do;
         if findc(PROD_ATTR_VALUE,"&etlp_exclude_char_list") > 0
                  then ETLS_EXCEPTION_COND = cats(ETLS_EXCEPTION_COND, '0a'x, "%etl_msg(mid=5358,args=PROD_ATTR_VALUE)");
            _ERROR_=0;
         end;

         /* 3 = integer  */
         when (3) do;
            if not(int(missing(input(PROD_ATTR_VALUE,nlnum12.)))=0 and int(input(PROD_ATTR_VALUE,nlnum12.))=input(PROD_ATTR_VALUE ,nlnum12.))
            then ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
            else PROD_ATTR_VALUE = cats(INT(put(input(PROD_ATTR_VALUE,nlnum12.),nlbest12.)));
            _ERROR_=0;
         end;

         /* 4 = boolean  */
         when (4) do;
            if NOT(input(PROD_ATTR_VALUE,nlnum12.)=0 OR input(PROD_ATTR_VALUE,nlnum12.)=1)
            then ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
            else PROD_ATTR_VALUE = cats(input(PROD_ATTR_VALUE,32.));
            _ERROR_=0;
         end;

         /* 5 = date */
         when (5) do;
            if missing(input(PROD_ATTR_VALUE,&etlp_date_format))
            then do;
               ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
               _ERROR_=0;
            end;
            else PROD_ATTR_VALUE=put((input(PROD_ATTR_VALUE,&etlp_date_format)),date9.);
         end;

         /* 6 = datetime */
         when (6) do;
            if missing(input(PROD_ATTR_VALUE,&etlp_datetime_format))
            then do;
               ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
               _ERROR_=0;
            end;
            else PROD_ATTR_VALUE=compress(put((input(PROD_ATTR_VALUE,&etlp_datetime_format)),datetime19.));
         end;

         /* 7 = percentage */
         when (7) do;
            if (input(PROD_ATTR_VALUE,nlnum12.2)<0 OR input(PROD_ATTR_VALUE,nlnum12.2)>100)
            then do;
               ETLS_EXCEPTION_COND = put(cats(ETLS_EXCEPTION_COND,'0a'x,"%etl_msg(mid=5435,args=PROD_ATTR_VALUE ATTR_TYPE)"),$300.);
               _ERROR_=0;
            end;

         end;

        otherwise;
      end; /* End of select */
   end;
   if MISSING(ETLS_EXCEPTION_COND) then
      output work.Splt_no_duplicates;
   else do;
      ETL_ERROR_JOBRUNTIME= "&etls_startTime"dt;
      output work.Splt_duplicates;
   end;
run;
options &callernotes;


/*---- End of User Written Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);


/*============================================================================*
 * Step:            Load_stg_product_attributes_x           A5W0V4GZ.BH000HWS *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Splt_duplicates - work.Splt_duplicates  A5W0V4GZ.BK000ENM *
 * Target Table:    STG_PRODUCT_ATTRIBUTES_X -              A5W0V4GZ.BB0007V7 *
 *                   DI_MON.STG_PRODUCT_ATTRIBUTES_X                          *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWS);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.Splt_duplicates);

/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(Splt_duplicates Splt_no_duplicates);

/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

/*---- Define load data macro  ----*/
/* --------------------------------------------------------------
   Load Technique Selection: AppendToExisting - AppendProc
   Constraint and index action selections: 'ASIS','ASIS','ASIS','ASIS'
   Additional options selections...
      Set unmapped to missing on updates: false
   -------------------------------------------------------------- */

      %let etls_recordsBefore = %di_util_nobs(DI_MON.STG_PRODUCT_ATTRIBUTES_X);
      %let etls_table = %nrquote(STG_PRODUCT_ATTRIBUTES_X);
      %let etls_lib   = %nrquote(DI_MON);

      /*---- Append  ----*/
      %put %str(NOTE: Appending data ...);

      proc append base = DI_MON.STG_PRODUCT_ATTRIBUTES_X
                  data = work.Splt_duplicates force;
      run;

       %let etls_recordsAfter = %di_util_nobs(DI_MON.STG_PRODUCT_ATTRIBUTES_X);





/**  Step end Load_stg_product_attributes_x **/

/*============================================================================*
 * Step:            Lkp_product_attributes                  A5W0V4GZ.BH000HWT *
 * Transform:       Lookup                                                    *
 * Description:                                                               *
 *                                                                            *
 * Source Tables:   Splt_no_duplicates -                    A5W0V4GZ.BK000ENL *
 *                   work.Splt_no_duplicates                                  *
 *                  PRODUCT_ATTRIBUTES -                    A5W0V4GZ.BB00082X *
 *                   DI_DM.PRODUCT_ATTRIBUTES                                 *
 * Target Table:    Lkp_product_attributes -                A5W0V4GZ.BK000ENN *
 *                   work.Lkp_product_attributes                              *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWT);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(Splt_no_duplicates);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

%let runTime = %sysfunc(datetime());

%Macro etls_lkp_product_attributes;

   %if &etlp_use_hash_lookup=1 %then %do;
   /* Creating view to eliminate column name collisions for lookup table  */
   /*  DI_DM.PRODUCT_ATTRIBUTES                                           */
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_temp_lookupview0;
   quit;

   proc sql; create view etls_temp_lookupview0 as
      select
         PROD_ATTR_VALUE as ETLS_W5RYTLP3,
         PROD_HIER_SK,
         PROD_ATTR_SK
      from DI_DM.PRODUCT_ATTRIBUTES
      ;
   quit;
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete Lkp_product_attributes;
   quit;

/*---- Begin DATA step to perform lookups  ----*/
   DATA  work.Lkp_product_attributes
            ( keep = PROD_HIER_SK PROD_ATTR_SK PREV_ATTR_VALUE PROD_ATTR_VALUE CHANGE_FLG )
         ;

      attrib PROD_HIER_SK length=6
             PROD_ATTR_SK length=4
             PREV_ATTR_VALUE length=$40
             PROD_ATTR_VALUE length=$40
             CHANGE_FLG length=$1
             ETLS_W5RYTLP3 length= $40
             ;

      retain missing0-missing0 0;

      etls_assign_target_value = 0;
      /* Build hash objects from lookup tables before reading first source row  */
      if (_n_ = 1) then
      do;
         /* Build hash h0 from lookup table etls_temp_lookupview0 */
         nlobs = .;
         dsid = open("etls_temp_lookupview0");
         if (dsid > 0) then
         do;
            if ( attrc(dsid, 'MTYPE') = 'DATA' ) then
               nlobs = attrn(dsid, 'NLOBS');
            else
               nlobs = -1;

            dsid = close(dsid);
            if (nlobs ^= 0) then
            do;
               if (nlobs > 0) then
                  exponent = ceil(log2(nlobs));
               else
                  exponent = 8;
               declare hash h0(dataset: "etls_temp_lookupview0", hashexp: exponent);
               h0.defineKey( "PROD_HIER_SK",
                              "PROD_ATTR_SK");
               h0.defineData( "ETLS_W5RYTLP3");
               h0.defineDone();
               if (nlobs = -1) then
               do;
                  if (h0.Num_Items < 1) then
                  do;
                     put "NOTE: Lookup table is empty: etls_temp_lookupview0";
                     missing0 = 98;
                  end;
               end;
            end;
            else
            do;
               put "NOTE: Lookup table is empty: etls_temp_lookupview0";
               missing0 = 98;
            end;
         end;
         else
         do;
            put "NOTE: Lookup table does not exist or cannot be opened:"
                 " etls_temp_lookupview0";

            put "NOTE: Abort action indicated, condition= Lookup table missing:"
                 " etls_temp_lookupview0";

            abort 3;
         end;

         call missing (PROD_HIER_SK, PROD_ATTR_SK, ETLS_W5RYTLP3);

      end; /* All hash objects have been defined */

      /* Read a row from the source table  */
      set work.Splt_no_duplicates end = eof;
      if UPCASE(CHANGE_FLG) ne ("&etl_delete_flg");
      /* Is the current key value stored in hash h0?  */
      if (missing0 < 1) then
      do;
         rc0 = h0.find();
         PREV_ATTR_VALUE = ETLS_W5RYTLP3;
      end;
      else
         rc0 = missing0;

      /* Examine success of lookups  */
      if ( rc0=0 ) then
      do;
         /* Write row to target  */
         output work.Lkp_product_attributes;
         return;
      end;
      else
      do;
         error_total + 1;

         if (rc0 ^= 0) then
         do;
            exception_total + 1;
            if (rc0 = 98) then
            do;
               /* Check: Lookup table has no rows-Write exception row  */
               /* Check: Lookup table has no rows-Set target columns to value  */
            end;

            else
            do;
               /* Check: Lookup value not found-Set target columns to missing  */
               call missing (PREV_ATTR_VALUE);
               etls_assign_target_value = 1;
            end;
         end;

         /* Set target columns to value/missing requested?  */
         if (etls_assign_target_value eq 1) then
            /* Write row to target  */
            output work.Lkp_product_attributes;

      end; /* One or more lookups failed */

      if (eof = 1) then
      do;
         put "Source records with errors: " error_total ;
         put "Total lookup exceptions: " exception_total ;
      end;

   run;

   %rcSet(&syserr);

   %end;
   %else %do;

      %local rbefore_product_attributes;
      %let rbefore_product_attributes = %di_util_nobs(di_dm.Product_attributes);

      data Lkp_product_attributes;
         set Splt_no_duplicates(keep=prod_hier_sk prod_attr_sk prod_attr_value change_flg);
         set di_dm.Product_attributes (rename=(PROD_ATTR_VALUE=PREV_ATTR_VALUE)) key=prim_key;
         if _iorc_=%sysrc(_dsenom) then do;
            _error_=0;
            call missing(PREV_ATTR_VALUE);
         end;
         if upcase(change_flg)="&etl_delete_flg" then delete;
         %if &rbefore_product_attributes eq 0 %then %do;
         stop;
         %end;
      run;

   %rcSet(&syserr);
   %end;

%mend etls_lkp_product_attributes;

%etls_lkp_product_attributes


/**  Step end Lkp_product_attributes **/

/*============================================================================*
 * Step:            Ext_product_attributes                  A5W0V4GZ.BH000HWU *
 * Transform:       Extract                                                   *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Lkp_product_attributes -                A5W0V4GZ.BK000ENN *
 *                   work.Lkp_product_attributes                              *
 * Target Table:    Ext_product_attributes -                A5W0V4GZ.BK000ENO *
 *                   work.Ext_product_attributes                              *
 *============================================================================*/

%let transformID = %quote(A5W0V4GZ.BH000HWU);
%let trans_rc = 0;
%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%let SYSLAST = %nrquote(work.Lkp_product_attributes);

%let ETLS_SYSLAST = &SYSLAST;
/*---- Start of Pre-Process Code  ----*/

%di_etl_keep_work_table(Lkp_product_attributes Splt_no_duplicates);
/*---- End of Pre-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);

%let SYSLAST = &ETLS_SYSLAST;

/*---- Map the columns  ----*/
proc datasets lib = work nolist nowarn memtype = (data view);
   delete Ext_product_attributes;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql;
   create view work.Ext_product_attributes as
      select
         (DATE()) as HIER_CHANGE_DT length = 8
            format = DATE9.
            informat = DATE9.,
         (1) as HIER_TYPE length = 4,
         PROD_HIER_SK as HIER_SK,
         PROD_ATTR_SK as ATTR_SK length = 6,
         PREV_ATTR_VALUE,
         PROD_ATTR_VALUE as ATTR_VALUE
   from &SYSLAST
      where PREV_ATTR_VALUE ne ATTR_VALUE
   ;
quit;

%let SYSLAST = work.Ext_product_attributes;

%rcSet(&sqlrc);



/**  Step end Ext_product_attributes **/

/*============================================================================*
 * Step:            Load_attribute_history                  A5W0V4GZ.BH000HWV *
 * Transform:       Table Loader (Version 2.1)                                *
 * Description:                                                               *
 *                                                                            *
 * Source Table:    Ext_product_attributes -                A5W0V4GZ.BK000ENO *
 *                   work.Ext_product_attributes                              *
 * Target Table:    ATTRIBUTE_HISTORY -                     A5W0V4GZ.BB0007YF *
 *                   DI_DM.ATTRIBUTE_HISTORY                                  *
 *============================================================================*/

%let etls_stepStartTime = %sysfunc(datetime(), datetime20.);

%di_etl_keep_work_table(Ext_product_attributes Lkp_product_attributes Splt_no_duplicates);

%rcSet(&syserr);
%rcSet(&sqlrc);

/*---- Define load data macro  ----*/

%macro etls_loader;

   /* Get number of records in table  */
   %let etls_recordsBefore = %di_util_nobs(di_dm.ATTRIBUTE_HISTORY);

   %let etls_table = %nrquote(ATTRIBUTE_HISTORY);
   %let etls_lib   = %nrquote(DI_DM);

   /* Determine if the target table exists  */
   %let etls_tableExist = %eval(%sysfunc(exist(DI_DM.ATTRIBUTE_HISTORY, DATA)) or
                                %sysfunc(exist(DI_DM.ATTRIBUTE_HISTORY, VIEW)));

   /*---- Create a new table  ----*/
   %if (&etls_tableExist eq 0) %then
   %do;  /* if table does not exist  */

      %put %str(NOTE: Creating table ...);

      data DI_DM.ATTRIBUTE_HISTORY;
         attrib HIER_CHANGE_DT length = 8
            format = DATE9.
            informat = DATE9.;
         attrib HIER_TYPE length = 4;
         attrib HIER_SK length = 6;
         attrib ATTR_SK length = 6;
         attrib PREV_ATTR_VALUE length = $40;
         attrib ATTR_VALUE length = $40;
         call missing(of _all_);
         stop;
      run;

      %rcSet(&syserr);

      /*---- Create the integrity constraints for a table  ----*/
      %put %str(NOTE: Creating integrity constraints ...);
      proc datasets library=DI_DM nolist;
         modify ATTRIBUTE_HISTORY;
            ic create not null (HIER_CHANGE_DT);
            ic create not null (HIER_TYPE);
            ic create not null (HIER_SK);
            ic create not null (ATTR_SK);
            ic create not null (ATTR_VALUE);
            ic create PRIM_KEY = primary key (HIER_CHANGE_DT HIER_TYPE HIER_SK ATTR_SK);
      quit;

      %rcSet(&syserr);

   %end;  /* if table does not exist  */

   %di_util_lock(di_dm.ATTRIBUTE_HISTORY);

   data DI_DM.ATTRIBUTE_HISTORY;
      set Ext_product_attributes (rename=(PREV_ATTR_VALUE = etls_temp0
                                          ATTR_VALUE = etls_temp1));
      modify DI_DM.ATTRIBUTE_HISTORY
             key = PRIM_KEY;

      if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or
         _iorc_ eq %sysrc(_SOK) then
      do;
         PREV_ATTR_VALUE = etls_temp0;
         ATTR_VALUE = etls_temp1;

         /* if the record exists in the master, then replace it  */
         if _iorc_ eq %sysrc(_SOK) then
            replace;
         /* if the record does not exist in the master, then add it  */
         else
            output;
      end;
      _iorc_ = 0;
      _error_ = 0;
   run;

   %di_util_unlock(di_dm.ATTRIBUTE_HISTORY);

   %rcSet(&syserr);

%mend etls_loader;
%etls_loader;

/*---- Start of Post-Process Code  ----*/
%let etls_recordsAfter=%di_util_nobs(di_dm.ATTRIBUTE_HISTORY);
%rcSet(&syserr);

%let etls_endTime = %sysfunc(datetime(),datetime.);

/*---- Job status macro  ----*/
%etls_sendjobstatus;
/*---- End of Post-Process Code  ----*/

%rcSet(&syserr);
%rcSet(&sqlrc);



/**  Step end Load_attribute_history **/

/*---- Start of User Written Code  ----*/

%let keep_col=PROD_HIER_SK PROD_ATTR_SK PROD_ATTR_VALUE CHANGE_FLG;
data del_records(keep=&keep_col)
     load_records(keep=&keep_col);
set Splt_no_duplicates;
if UPCASE(CHANGE_FLG) eq ("&etl_delete_flg") then
 output del_records;
else output  load_records;
run;

/* Get record count from product_attributes  before load */
%let etls_recordsBefore=%di_util_nobs(DI_DM.PRODUCT_ATTRIBUTES);

/* Delete the records from  DI_DM.PRODUCT_ATTRIBUTES with Change_flg='D'*/

data di_dm.product_attributes;
set del_records;
modify  di_dm.product_attributes key= PRIM_KEY;
if %sysrc(_SOK) eq _iorc_  then remove;
else _error_=0;
run;

%rcSet(&syserr);
%global etls_recordsBefore_pal etls_recordsafter_pal;
%let etls_recordsBefore_pal=%di_util_nobs(DI_DM.Product_attr_lookup);
/* Delete the same records from  DI_DM.PRODUCT_ATTR_LOOKUP */
%put deleting from PRODUCT_ATTR_LOOKUP;

data di_dm.PRODUCT_ATTR_LOOKUP;
set del_records;
modify  di_dm.PRODUCT_ATTR_LOOKUP key= PRIM_KEY;
if %sysrc(_SOK) eq _iorc_  then remove;
else _error_=0;
run;

%let etls_recordsafter_pal=%di_util_nobs(DI_DM.Product_attr_lookup);

/* Update & Insert  the records from  DI_DM.PRODUCT_ATTRIBUTES with Change_flg not equal 'D'*/
data di_dm.product_attributes;
     set load_records(rename =(PROD_ATTR_VALUE=attr_value));
      modify di_dm.product_attributes key = PRIM_KEY;
            if _iorc_ in( %sysrc(_DSENMR),%sysrc(_DSENOM),%sysrc(_DSEMTR)) or
         _iorc_ eq %sysrc(_SOK) then
      do;
          PROD_ATTR_VALUE = attr_value;
         /* if the record exists in the master, then replace it  */
         if _iorc_ eq %sysrc(_SOK) then
            replace;
         /* if the record does not exist in the master, then add it  */
         else
            output;
       end;
        _iorc_ = 0;
        _error_ = 0;
      run;

%rcSet(&syserr);
%di_etl_rcSet(error=&syscc,code=job_rc);
/* Get record count from product_attributes after load */
%let etls_recordsAfter=%di_util_nobs(DI_DM.PRODUCT_ATTRIBUTES);
/*   Record job status for product_attributes table  */
%let etls_lib   = %nrquote(DI_DM);
%let etls_endTime=%sysfunc(putn(%sysfunc(datetime()), datetime21.));
%let etls_table = %nrquote(PRODUCT_ATTRIBUTES);
/*---- End of User Written Code  ----*/
%let etls_endTime = %sysfunc(datetime(),datetime.);
/*---- Job status macro  ----*/
%etls_sendjobstatus(source_table = didm_stg.stg_product_attributes);


%let etls_recordsBefore=&etls_recordsBefore_pal.;
%let etls_recordsafter=&etls_recordsafter_pal.;

/*   Record job status for product_attributes table  */
%let etls_lib   = %nrquote(DI_DM);
%let etls_endTime=%sysfunc(putn(%sysfunc(datetime()), datetime21.));
%let etls_table = %nrquote(PRODUCT_ATTR_LOOKUP);
%etls_sendjobstatus(source_table = didm_stg.stg_product_attributes);
